# Visualization
TKV3d
Select3D

# Select3D_SensitiveTriangle Class Reference

A framework to define selection of triangles in a view.
This comes into play in the detection of meshing and triangulation in surfaces.
.

`#include <Select3D_SensitiveTriangle.hxx>`

Inheritance diagram for Select3D_SensitiveTriangle:

[legend]

## Public Member Functions

Standard_EXPORT | Select3D_SensitiveTriangle (const Handle(SelectBasics_EntityOwner)&OwnerId, const gp_Pnt &P1, const gp_Pnt &P2, const gp_Pnt &P3, const Select3D_TypeOfSensitivity Sensitivity=Select3D_TOS_INTERIOR)
| Constructs a sensitive triangle object defined by the owner OwnerId, the points P1, P2, P3, and the type of sensitivity Sensitivity. .
virtual Standard_EXPORT Standard_Boolean | Matches (const Standard_Real X, const Standard_Real Y, const Standard_Real aTol, Standard_Real &DMin)
| Matches the coordinates X, Y with the entity found at that point within the tolerance aTol and the minimum depth DMin. You must redefine this function for every inheriting entity. You will have to call this framework inside the redefined function. .
virtual Standard_EXPORT Standard_Boolean | Matches (const Standard_Real XMin, const Standard_Real YMin, const Standard_Real XMax, const Standard_Real YMax, const Standard_Real aTol)

Matches the box defined by the coordinates Xmin,
Ymin, Xmax, Ymax with the entity found at that point
within the tolerance aTol.
Xmin, YMin define the minimum point in the lower left
hand corner of the box, and XMax, YMax define the
maximum point in the upper right hand corner of the box.
You must redefine this function for every inheriting entity.
You will have to call this framework inside the redefined function.
.

virtual Standard_EXPORT Standard_Boolean | Matches (const TColgp_Array1OfPnt2d &Polyline, const Bnd_Box2d &aBox, const Standard_Real aTol)
| prevents from hiding virtual methods...
Standard_EXPORT Standard_Real | ComputeDepth (const gp_Lin &EyeLine) const
| Returns the depth of this object on the line EyeLine. EyeLine goes through the eye towards a point defined by the coordinates X,Y in the function GetEyeLine. //! gives an abcissa on <alin> . <alin> represents the line going through the eye towards an X,Y point on the screen. This Method must return a mean Depth on this line. .
Standard_EXPORT void | Points3D (gp_Pnt &P1, gp_Pnt &P2, gp_Pnt &P3) const
| Returns the 3D points P1, P2, P3 used at the time of construction. .
Standard_EXPORT gp_Pnt | Center3D () const
| Returns the center point of the sensitive triangle created at construction time. .
Standard_EXPORT gp_XY | Center2D () const
| WARNING : the returned Values are the original values without the stored location (if there's one). To get the genuine value, One must apply this location (Method Location() ) .
Standard_EXPORT Standard_Integer | Status (const Standard_Real X, const Standard_Real Y, const Standard_Real aTol, Standard_Real &Dmin) const
virtual Standard_EXPORT void | Dump (Standard_OStream &S, const Standard_Boolean FullDump=Standard_True) const
| 2 options : <fulldump> = False -> general information <fulldump> = True -> whole informtion 3D +2d ...
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT Standard_Integer | Status (const gp_XY &p0, const gp_XY &p1, const gp_XY &p2, const gp_XY &aPoint, const Standard_Real aTol, Standard_Real &Dmin)
| Dmin gives the distance between the cdg and aPoint return .

## Private Attributes

Select3D_TypeOfSensitivity | mytype

## Constructor & Destructor Documentation

Standard_EXPORT Select3D_SensitiveTriangle::Select3D_SensitiveTriangle | ( | const Handle(SelectBasics_EntityOwner)& | OwnerId,
|  | const gp_Pnt & | P1,
|  | const gp_Pnt & | P2,
|  | const gp_Pnt & | P3,
|  | const Select3D_TypeOfSensitivity | Sensitivity = `Select3D_TOS_INTERIOR`
| ) |

## Member Function Documentation

Standard_EXPORT gp_XY Select3D_SensitiveTriangle::Center2D | ( |  | ) | const

Standard_EXPORT gp_Pnt Select3D_SensitiveTriangle::Center3D | ( |  | ) | const

Standard_EXPORT Standard_Real Select3D_SensitiveTriangle::ComputeDepth | ( | const gp_Lin & | EyeLine | ) | const`[virtual]`

| Implements Select3D_SensitiveEntity.

virtual Standard_EXPORT void Select3D_SensitiveTriangle::Dump | ( | Standard_OStream & | S,
|  | const Standard_Boolean | FullDump = `Standard_True`
| ) | const`[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT const Select3D_SensitiveTriangle::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from Select3D_SensitivePoly.

virtual Standard_EXPORT Standard_Boolean Select3D_SensitiveTriangle::Matches | ( | const TColgp_Array1OfPnt2d & | Polyline,
|  | const Bnd_Box2d & | aBox,
|  | const Standard_Real | aTol
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT Standard_Boolean Select3D_SensitiveTriangle::Matches | ( | const Standard_Real | XMin,
|  | const Standard_Real | YMin,
|  | const Standard_Real | XMax,
|  | const Standard_Real | YMax,
|  | const Standard_Real | aTol
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT Standard_Boolean Select3D_SensitiveTriangle::Matches | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Standard_Real | aTol,
|  | Standard_Real & | DMin
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT void Select3D_SensitiveTriangle::Points3D | ( | gp_Pnt & | P1,
|  | gp_Pnt & | P2,
|  | gp_Pnt & | P3
| ) | const

static Standard_EXPORT Standard_Integer Select3D_SensitiveTriangle::Status | ( | const gp_XY & | p0,
|  | const gp_XY & | p1,
|  | const gp_XY & | p2,
|  | const gp_XY & | aPoint,
|  | const Standard_Real | aTol,
|  | Standard_Real & | Dmin
| ) | `[static]`

Standard_EXPORT Standard_Integer Select3D_SensitiveTriangle::Status | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Standard_Real | aTol,
|  | Standard_Real & | Dmin
| ) | const

## Field Documentation

Select3D_TypeOfSensitivity Select3D_SensitiveTriangle::mytype `[private]`

The documentation for this class was generated from the following file:

- Select3D_SensitiveTriangle.hxx